/*******************************************************************************

  Defines Plug-in Library Interface for DIMIN Viewer n5 (DIV5)

  Programmer: Dima V. Fedorov Levit <dimin@dimin.net> <http://www.dimin.net/>

  Notes:

  ---------------------------------------
  |            DIVPluginDefs            |
  | each DLL export: divGetPluginHeader |
  ---------------------------------------
     |               |        ...
   Filters        Formats


  Version : 5

  History:
    08/15/2004 15:36 - v 5

*******************************************************************************/

#ifndef DIV_PLUGIN_DEFS_H
#define DIV_PLUGIN_DEFS_H

#include <windows.h>


#define DIV_PLUGIN_TYPE_FILTER  0 // Filter
#define DIV_PLUGIN_TYPE_FORMAT  1 // Format
#define DIV_PLUGIN_TYPE_FORFIL  2 // Format and Filter

#define DIV_PLUGIN_ENTRY_NAME  "divGetPluginHeader"
  
//****************************************************************************
// Plugin Headers
//****************************************************************************

  typedef struct TDIVPluginHeader {
    DWORD ver;         // sizeof( TDIVPluginHeader )
    DWORD divVersion;  // DIV version for witch plugin's written
    DWORD pluginType;  // Plug-in type ( Filter, Format... )
    DWORD version;     // Plug-in version
    DWORD count;       // Number of procs in library (better fill for filters)
    char *description; // Text about plugin library
  } TDIVPluginHeader;



//****************************************************************************
// Filter DLL Functions
//****************************************************************************

  //divGetPluginHeader
  typedef TDIVPluginHeader* (__stdcall *TDivGetPluginHeader)(void);


#endif //DIV_PLUGIN_DEFS_H
