#!/bin/bash

mkdir -p ffmpeg-obj
mkdir -p ffmpeg-out

cd ffmpeg-obj
../ffmpeg/configure \
	--cpu=i686 --disable-static --enable-shared \
	--prefix=$PWD/../ffmpeg-out \
	--enable-gpl --enable-swscaler \
	--disable-ffserver --disable-ffplay --disable-vhook --disable-network --disable-ffmpeg \
	--disable-devices --target-os="mingw32" \
	--disable-mmx --enable-w32threads \
	--extra-cflags="-mno-cygwin" \
	--extra-libs="-mno-cygwin"

#	--enable-memalign-hack --enable-w32threads \ # ok for reading but breaks on writing
# --disable-mmx --enable-w32threads \ # reads and writes ok

make all install

cp $(find . -name '*.def') ../ffmpeg-out
cd ../ffmpeg-out
rm avutil*.dll
rm avformat*.dll
rm avcodec*.dll
rm swscale*.dll
mv bin/avutil-49.*.dll ./avutil-49.dll
mv bin/avformat-52.*.dll ./avformat-52.dll
mv bin/avcodec-51.*.dll ./avcodec-51.dll
mv bin/swscale-0.*.dll ./swscale-0.dll


cp $(find ./include/ffmpeg -name '*.h') ../include/ffmpeg

echo "
set PATH=C:\Program Files\Microsoft Visual Studio 9.0\VC\bin;%PATH%
set PATH=C:\Program Files\Microsoft Visual Studio 9.0\Common7\IDE;%PATH%
lib /machine:x86 /def:avutil-49.def
lib /machine:x86 /def:avformat-52.def
lib /machine:x86 /def:avcodec-51.def
lib /machine:x86 /def:swscale-0.def
del *.exp
copy *.dll ..\..\..\libs\vc2005
copy *.lib ..\..\..\libs\vc2005" > makedlls.bat

chmod a+x makedlls.bat

./makedlls.bat
