/*******************************************************************************
  
  Map for tag/value pairs
    
  Author: Dima Fedorov Levit <dimin@dimin.net> <http://www.dimin.net/>

  History:
    2008-03-18 17:13 - First creation
      
  ver: 1
        
*******************************************************************************/

#ifndef D_TAG_MAP_H
#define D_TAG_MAP_H

#include <string>
#include <map>

class DTagMap : public std::map<std::string, std::string>
{
public:
  // constructors
  explicit DTagMap(): std::map<std::string, std::string>() {}
  DTagMap( const DTagMap& _Right ): std::map<std::string, std::string>(_Right) {}
  DTagMap( const std::map<std::string, std::string>& _Right ): std::map<std::string, std::string>(_Right) {}

  template<class InputIterator>
  DTagMap( InputIterator _First,
           InputIterator _Last ): std::map<std::string, std::string>(_First, _Last) {}


  // additional methods
  std::string get_value( const std::string &key, const std::string &def ) const;
  int         get_value_int( const std::string &key, const int &def ) const;
  double      get_value_double( const std::string &key, const double &def ) const;

  void append_tag( const std::string &key, const std::string &value );
  void append_tag( const std::string &key, const int &value );
  void append_tag( const std::string &key, const double &value );

};

#endif // D_TAG_MAP_H


