/*****************************************************************************
  FFMPEG support 
  Copyright (c) 2008 by Dmitry V. Fedorov <www.dimin.net> <dima@dimin.net>

  IMPLEMENTATION
  
  Programmer: Dima V. Fedorov <mailto:dima@dimin.net> <http://www.dimin.net/>

  History:
    2008-02-01 14:45 - First creation
        
  Ver : 1
*****************************************************************************/

#ifndef DIM_FFMPEG_FORMAT_H
#define DIM_FFMPEG_FORMAT_H

#include <DIVFormatDefs.h>
#include <DIVFormatUtils.h>

#include <cstdio>
#include <vector>
#include <map>

#include "FfmpegIVideo.h"
#include "FfmpegOVideo.h"


DIM_INT          __stdcall dimFFMpegValidateFormatProc ( void *magic, DIM_UINT32 length);
TDivFormatHandle __stdcall dimFFMpegAquireFormatProc   ( void );
void             __stdcall dimFFMpegReleaseFormatProc  ( TDivFormatHandle *fmtHndl);
DIM_UINT         __stdcall dimFFMpegOpenImageProc      ( TDivFormatHandle *fmtHndl, TDIVIOModes io_mode);
void             __stdcall dimFFMpegCloseImageProc     ( TDivFormatHandle *fmtHndl);
DIM_UINT         __stdcall dimFFMpegGetNumPagesProc    ( TDivFormatHandle *fmtHndl );
TDivImageInfo    __stdcall dimFFMpegGetImageInfoProc   ( TDivFormatHandle *fmtHndl, DIM_UINT page_num );
DIM_UINT         __stdcall dimFFMpegAddMetaDataProc    ( TDivFormatHandle *fmtHndl);
DIM_UINT         __stdcall dimFFMpegReadMetaDataProc   ( TDivFormatHandle *fmtHndl, DIM_UINT page, int group, int tag, int type);
char*            __stdcall dimFFMpegReadMetaDataAsTextProc ( TDivFormatHandle *fmtHndl );
DIM_UINT         __stdcall dimFFMpegReadImageProc      ( TDivFormatHandle *fmtHndl, DIM_UINT page );
DIM_UINT         __stdcall dimFFMpegWriteImageProc     ( TDivFormatHandle *fmtHndl );
void             __stdcall dimFFMpegConfigInitProc     ( TDivFormatHandle *fmtHndl, HWND hwndParent );
void             __stdcall dimFFMpegConfigQuitProc     ( TDivFormatHandle *fmtHndl, HWND hwndParent );

void             __stdcall dimFFMpegLoadRegProc ( TDivFormatHandle *fmtHndl );
void             __stdcall dimFFMpegSaveRegProc ( TDivFormatHandle *fmtHndl );

//----------------------------------------------------------------------------
// Internal Format Structs
//----------------------------------------------------------------------------

typedef struct TDimFFMpegParams
{
  TDivImageInfo i;
  VideoIO::FfmpegIVideo ff_in;
  VideoIO::FfmpegOVideo ff_out;
  bool frame_sizes_set;
  float fps;
  int bitrate;
} TDimFFMpegParams;

static std::vector< std::string > formats_write;
static std::vector< std::string > formats_fourcc;
static std::vector< CodecID > encoder_ids;
static std::map< std::string, int > formats;
static std::map< std::string, int > codecs;

#endif // DIM_FFMPEG_FORMAT_H
